# $Header: /home/hiro/projects/dvr2/RCS/dist.mk,v 1.1 2012/07/12 00:40:27 hiro Exp $
#
#	== Project DVR2 ==
#
#	Makefile fragment for distribution packaging
#
#	Copyright (c) 2012 Hiro Sugawara

rcsdiff	:= $(foreach file,$(DIST-PATCH),\
	rcsdiff -r1.1 -pu $(subst $(CWD)/,,$(file));)

patch-file	:= dvr2.patch
config-file	:= config.mk

DIST-FILES	+= 	\
	$(CWD)/Makefile	\
	$(CWD)/dist.mk

dist-version	:= dvr2-$(shell date +%Y%m%d)
dist-file	:= $(dist-version).tgz
DIST-DIR	:= /var/www/html2/projects/tv/download
DIST-FPAT	:= dvr2-20[1-9][0-9][12][0-9]
TMP-DIR		:= $(dist-version)

DIST-ALL: $(dist-file)
$(dist-file): $(sort $(subst $(CWD)/,,$(DIST-FILES)))
	@if [ -d $(TMP-DIR) ];	\
	then	\
		echo "$(TMP-DIR) already exists." >&2;	\
		exit 1;	\
	fi
	mkdir $(TMP-DIR)
	tar -cf - $^ | tar -C $(TMP-DIR) -xf -
	sed 's|\(PASSWD[[:space:]]*:=\).*$$|\1 <your_password>|;s|^ARKUSA.*$$||'	\
		<$(config-file) >$(TMP-DIR)/$(config-file).sample
	sh -c "$(rcsdiff) true" >$(TMP-DIR)/$(patch-file) 2>/dev/null
	tar -czf $(dist-file) $(TMP-DIR)

DIST-INSTALL: $(dist-file)
	$(MKDIR) -p -m 755 $(DIST-DIR)
	$(CHOWN) apache.apache $(DIST-DIR)
	@if ls $(DIST-DIR)/$(DIST-FPAT).tgz >/dev/null 2>&1;	\
	then	\
		latest=`ls -t -1 $(DIST-DIR)/$(DIST-FPAT).tgz | head -1`;	\
		cs1="`cksum $$latest | awk '{ print $$1,$$2 }'`";	\
		cs2="`cksum $(dist-file) | awk '{ print $$1,$$2 }'`";	\
		if [ "$$cs1" = "$$cs2" ];	\
		then	\
			echo "$(dist-file) is identical to $$latest." >&2;	\
			exit 1;	\
		fi	\
		$(INSTALL) -m 0644 $(dist-file) $(DSIT-DIR);	\
		$(LN) -f $(dist-file) $(DIST-DIR)/dvr2.tgz;	\
	fi

DIST-CLEAN:
	rm -f dvr2-20*.tgz *.sample $(patch-file)
